# Set the defaults if not already set.  Setting PORTS_CXX externally
# is only necessary if PORTS_CC is neither gcc nor clang.

.if defined(PORTS_CC)
_PORTS_CC?=		${PORTS_CC}
.else
_PORTS_CC?= 	gcc
.endif
.if defined(PORTS_CXX)
_PORTS_CXX?=	${PORTS_CXX}
.else
_PORTS_CXX?=	g++
.endif

# Handle cases of USE_CC.

.if ! defined(USE_CC)

CC=			${_PORTS_CC}
CXX=		${_PORTS_CXX}

.else

# For "base", force usage of system default compilers.
. if ${USE_CC} != "base"

# USE_CC is not "base", so check if port requires specific compiler
.  if !empty(USE_CC:Mgcc*)
_PORTS_CC=	gcc
.  elif !empty(USE_CC:Mclang*)
_PORTS_CC=	clang
.  endif

# Handle cases of _PORTS_CC

# GCC case

.  if !empty(_PORTS_CC:M*gcc*)
# These are set early so that USE_GCC can override later if neccessary.
CC=			${_PORTS_CC}
CXX=		${_PORTS_CC:S/cc/++/}
.  endif

# Translate USE_CC if the former is defined, and use it to override USE_GCC.
.  if defined(USE_CC) && !empty(USE_CC:Mgcc*)
USE_GCC=	${USE_CC:Mgcc*:S/gcc//}
.  else
# set a fallback to force inclusion of bsd.gcc.mk
USE_GCC?=	yes
.  endif

# If USE_GCC is defined, doesn't require specific version and accepts version
# from _PORTS_CC, override USE_GCC with version from _PORTS_CC.
.  if defined(USE_GCC) && USE_GCC != "yes" && !empty(USE_GCC:M*+) && !empty(_PORTS_CC:Mgcc??)
.   if ${_PORTS_CC:C/gcc([0-9])([0-9])/\1.\2/} > ${USE_GCC:S/+//}
USE_GCC=${_PORTS_CC:C/gcc([0-9])([0-9])/\1.\2/}
.   endif
.  endif


# Clang case
.  elif !empty(_PORTS_CC:Mclang*)
CC=			${_PORTS_CC}
CXX=		${_PORTS_CC:S/$/++/}

# fallback case.  _PORTS_CC is set to something weird.
.  else
CC=			${_PORTS_CC}
CXX=		${_PORTS_CXX}

.  endif

. endif # ${USE_CC} != "base"

.endif # ! defined(USE_CC)
